<%@ Page EnableViewState="false" Language="C#" %>
    
<script runat="server">
    //   C#   
    protected void Page_Load(object sender, EventArgs e)
    {
        //     -   
        passwordValidator.ErrorMessage = 
            "      7 "
            + "      - ";
    }
    
    protected void AddUserMembership_Click(object sender, EventArgs e)
    {
        this.Validate();//    
        if (!this.IsValid)//   
            return;//    
    
        //   
        MembershipCreateStatus status;
    
        //  
        try
        {
            Membership.CreateUser(
                username.Text,
                password.Text,
                email.Text,
                question.Text,
                answer.Text,
                true,
                out status
                );
    
            lblResult.Text = String.Empty;
            switch (status)
            {
                case MembershipCreateStatus.DuplicateUserName:
                    lblResult.Text = "  <br/>";
                    goto default;
                case MembershipCreateStatus.ProviderError:
                    lblResult.Text = " <br/>";
                    goto default;
                default: //   
                    lblResult.Text += "  ";
                    lblResult.ForeColor = System.Drawing.Color.Red;
                    break;
                case MembershipCreateStatus.Success:
                    //   
                    lblResult.Text = " " + username.Text 
                        + "  !";
                    //      
                    EmptyTextBox(form1.Controls);
                    lblResult.Text += "<br/>  ";
                    break;
            }
        }
        // 
        catch (MembershipCreateUserException ex)
        {
            lblResult.Text = "<h2 style='color: Red'>  </h2>";
            System.Diagnostics.Debug.WriteLine("Exception: "
                + ex.Message);
        }
    }
    
    private void EmptyTextBox(ControlCollection controls)
    {
        foreach (Control ctrl in controls)
        {
            if (ctrl is TextBox)
                ((TextBox)ctrl).Text = String.Empty;
    
            //         
            if (ctrl.Controls != null)
                EmptyTextBox(ctrl.Controls);
        }
    }
</script>
    
<script runat="server" language="C#">
//       C#,       
    
    //      
    //   ServerValidate  CustomValidator
    protected void passwordValidator_ServerValidate(object source, ServerValidateEventArgs args)
    {
        string data = args.Value;
    
        //     
        args.IsValid = false;
    
        //    
        if (data.Length < 7)
            return;
    
        //    
        //       ,
        //      
        int[] nonAlphanumericCharactersCode =
            {33,34,35,36,37,38,39,40,41,42,43,44,45,46,
             58,59,60,61,62,63,64,91,92,93,94,95,123,124,125,126};
        
        //    
        foreach (char ch in data)
        {
            for (int i = 0; i < nonAlphanumericCharactersCode.Length; i++)
                if (ch == Convert.ToChar(nonAlphanumericCharactersCode[i]))
                {
                    //   
                    args.IsValid = true;
                    return;
                }
        }
    }
</script>
    
<script language="javascript" type="text/javascript">
    //     .   
    //    EnableClientScript  CustomValidator
        
    function ValidatePassword(source, args)
    {
        //        
        var data = args.Value.split("");
        
        //     
        args.IsValid = false;
        
        //    
        if(data.length < 7)
            return;
            
        //    
        //       ,
        //      
        var nonAlphanumericCharactersString = 
            String.fromCharCode(33,34,35,36,37,38,39,40,41,42,43,44,45,46,
                                58,59,60,61,62,63,64,91,92,93,94,95,123,124,125,126);             
        for(var ch in data)
        {
            if(nonAlphanumericCharactersString.indexOf(data[ch]) != -1)
            {
                //   
                args.IsValid = true;           
                return;
            }
        }
    }
</script>
    
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>   </title>
</head>
<body>
    <form id="form1" runat="server">
        <div style="text-align: center">
            <h2 id="H2_1" runat="server">
                     </h2>
            <asp:Panel ID="MainPanel" runat="server" BorderColor="Silver" BorderStyle="Ridge"
                BorderWidth="2px" Height="90px" Width="364px">
                <table border="0" cellpadding="5" cellspacing="0" style="width: 137%">
                    <tr>
                        <td>
                            &nbsp;&nbsp;&nbsp;
                        </td>
                        <td align="right" height="43" style="width: 224px">
                            &nbsp;:
                        </td>
                        <td>
                            &nbsp;<asp:TextBox ID="username" runat="server">
                            </asp:TextBox>
                        </td>
                        <td>
                            <asp:RequiredFieldValidator ID="usernameRequiredValidator" runat="server" ControlToValidate="username"
                                Display="Dynamic" ErrorMessage='   " "'>*</asp:RequiredFieldValidator>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            &nbsp;&nbsp;&nbsp;
                        </td>
                        <td align="right" height="43" style="width: 224px">
                            &nbsp;:
                        </td>
                        <td>
                            &nbsp;<asp:TextBox ID="password" runat="server">
                            </asp:TextBox>
                        </td>
                        <td>
                            <asp:RequiredFieldValidator ID="passwordRequiredValidator" runat="server" ControlToValidate="password"
                                Display="Dynamic" ErrorMessage='   ""'>*</asp:RequiredFieldValidator>
                            <asp:CustomValidator ID="passwordValidator" runat="server" ClientValidationFunction="ValidatePassword"
                                ControlToValidate="password" Display="Dynamic" OnServerValidate="passwordValidator_ServerValidate">*</asp:CustomValidator>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            &nbsp;&nbsp;&nbsp;
                        </td>
                        <td align="right" height="43" style="width: 224px">
                            E-mail:</td>
                        <td>
                            &nbsp;<asp:TextBox ID="email" runat="server"></asp:TextBox>
                        </td>
                        <td>
                            <asp:RequiredFieldValidator ID="emailRequiredValidator" runat="server" ControlToValidate="email"
                                Display="Dynamic" ErrorMessage='   "E-mail"'>*</asp:RequiredFieldValidator>
                            <asp:RegularExpressionValidator ID="emailValidator" runat="server" ControlToValidate="email"
                                Display="Dynamic" ErrorMessage=" E-mail" ValidationExpression="\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*">*</asp:RegularExpressionValidator>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            &nbsp;&nbsp;&nbsp;
                        </td>
                        <td align="right" height="43" style="width: 224px">
                             :</td>
                        <td>
                            &nbsp;<asp:TextBox ID="question" runat="server"></asp:TextBox>
                        </td>
                        <td>
                            <asp:RequiredFieldValidator ID="questionRequiredValidator" runat="server" ControlToValidate="question"
                                Display="Dynamic" ErrorMessage='   " "'>*</asp:RequiredFieldValidator>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            &nbsp;&nbsp;&nbsp;
                        </td>
                        <td align="right" height="43" style="width: 224px">
                             :</td>
                        <td>
                            &nbsp;<asp:TextBox ID="answer" runat="server"></asp:TextBox>
                        </td>
                        <td>
                            <asp:RequiredFieldValidator ID="answerRequiredValidator" runat="server" ControlToValidate="answer"
                                Display="Dynamic" ErrorMessage='   " "'>*</asp:RequiredFieldValidator>
                        </td>
                    </tr>
                    <tr>
                        <td align="center" colspan="4">
                            <asp:Button ID="btnAddUser" runat="server" OnClick="AddUserMembership_Click" Text="" />
                        </td>
                    </tr>
                </table>
            </asp:Panel>
            <asp:Label ID="lblResult" runat="server" Font-Bold="True" Font-Size="Large" ForeColor="Blue">
            </asp:Label>
        </div>
        <asp:ValidationSummary ID="ValidationSummary1" runat="server" />
    </form>
</body>
</html>
